---
title: PaymentRequest.onpaymentmethodchange
slug: Web/API/PaymentRequest/onpaymentmethodchange
tags:
  - API
  - Commerce
  - Event Handler
  - Payment Method
  - PaymentRequest
  - Property
  - Reference
  - onpaymentmethodchange
  - payment
---
<p>{{securecontext_header}}{{APIRef("Payment Request API")}}</p>

<p><span class="seoSummary">The {{domxref("PaymentRequest")}} event handler <code><strong>onpaymentmethodchange</strong></code> is invoked when the {{event("paymentmethodchange")}} </span>is fired, indicating that the user has changed payment methods within a given payment handler. For example, when using Apple Pay, the user can swipe to select different credit cards, debit cards, and so forth. Each time the user does so, this event is fired.</p>

<p>This event may not be fired by all payment handlers.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">PaymentRequest.addEventListener('paymentmethodchange', paymentMethodChangeEvent =&gt; { ... });

PaymentRequest.onpaymentmethodchange = function(paymentMethodChangeEvent) { ... };</pre>

<h3 id="Value">Value</h3>

<p>An event handler function which is to be called whenever the {{event("paymentmethodchange")}} event is fired at the {{domxref("PaymentRequest")}}, indicating that the user has changed payment methods within the same payment handler.</p>

<p>The {{event("paymentmethodchange")}} event is triggered by a user-agent controlled interaction (i.e., the end-user switches from a debit to a credit card in the payment UI). To make sure you receive the event, you should add event listeners to {{domxref('PaymentRequest')}} object after instantiation, but before you call <code>show()</code>.</p>

<h2 id="Examples">Examples</h2>

<p>An example payment method change handler is shown below; this example handles changes made to the payment method when using Apple Pay, specifically:</p>

<pre class="brush: js">request.onpaymentmethodchange = ev =&gt; {
  const { type: cardType } = ev.methodDetails;
  const newStuff = {};
  if (ev.methodName === "https://apple.com/apple-pay") {
    switch (cardType) {
      case "store":
        // do Apple Pay specific handling for store card...
        // methodDetails contains the store card information
        const result = calculateDiscount(ev.methodDetails);
        Object.assign(newStuff, result);
        break;
    }
  }
  // finally...
  ev.updateWith(newStuff);
};
const response = await request.show();</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Payment', '#onpaymentmethodchange-attribute', 'onpaymentmethodchange')}}</td>
   <td>{{Spec2('Payment')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PaymentRequest.onpaymentmethodchange")}}</p>
</div>
